package com.goafanti.common.dao;

import com.goafanti.common.model.PublicConfig;
import com.goafanti.weChat.bo.OutPublicConfig;
import org.apache.ibatis.annotations.Param;
import org.springframework.data.domain.Pageable;

import java.util.List;

/**
 * 公出神最大审核配置(PublicConfig)表数据库访问层
 *
 * @author makejava
 * @since 2024-09-24 13:58:25
 */
public interface PublicConfigMapper {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    PublicConfig queryById(Integer id);


    /**
     * 查询指定行数据
     *
     * @param publicConfig 查询条件
     * @param pageable     分页对象
     * @return 对象列表
     */
    List<PublicConfig> findPublicConfigList(PublicConfig publicConfig, @Param("pageable") Pageable pageable);

    /**
     * 统计总行数
     *
     * @param publicConfig 查询条件
     * @return 总行数
     */
    int findPublicConfigCount(PublicConfig publicConfig);

    /**
     * 新增数据
     *
     * @param publicConfig 实例对象
     * @return 影响行数
     */
    int insert(PublicConfig publicConfig);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<PublicConfig> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<PublicConfig> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<PublicConfig> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<PublicConfig> entities);

    /**
     * 修改数据
     *
     * @param publicConfig 实例对象
     * @return 影响行数
     */
    int update(PublicConfig publicConfig);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 影响行数
     */
    int deleteById(Integer id);
    OutPublicConfig selectDetails();

}

